﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Xml;
using System.Threading;
namespace mapa
{
    public partial class Form1 : Form
    {
        public string srv = "http://192.168.2.76";
        public int port = 80;
        //x0 a y0 - posun dilku od zakladni mrizky
        int x0 = 0;
        int y0 = 0;
        int tmpx = 0;
        int tmpy = 0;
        int n = 0;
        //Centralni dilek
        Tile center;
        //Seznam mest
        public Dictionary<string, List<Point>> obce = new Dictionary<string,List<Point>>();
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            srv = textBox6.Text;
            try
            {
                port = Convert.ToInt32(textBox7.Text);
            }
            catch
            {
                MessageBox.Show("Please, insert a valid port number");
            }
            try
            {
                int x = Convert.ToInt32(textBox1.Text);
                int y = Convert.ToInt32(textBox2.Text);
                int z = Convert.ToInt32(textBox3.Text);
                try
                {
                    //Nacteni centralniho a okolnich dilku
                    center = new Tile(x, y, z);
                    drawAll(center, 1, 1);
                }
                catch
                {
                    MessageBox.Show("Tile doesn't exist!");
                }
            }
            catch
            {
                MessageBox.Show("Please, insert valid numbers");
            }
        }
        //Vykrelsi jeden dilek
        private void drawTile(Tile t, int x, int y) 
        {
            Graphics g = pictureBox1.CreateGraphics();
            g.DrawImage(t.img, x0 + x * 256, y0 + y * 256, 256, 256);
        }
        //Neexistuje li dilek, nakresli bilo
        private void drawEmpty(int x, int y)
        {
            Graphics g = pictureBox1.CreateGraphics();
            g.FillRectangle(Brushes.White, x * 256, y * 256, 256, 256);
        }
        //Vykresli vsechny sousedy centralniho diilku a centralni dilek
        private void drawAllNeigh(Tile center, int x, int y)
        {
            n = n + 1;
            try { drawTile(center, x, y);
            }
            catch
            {
                drawEmpty(x, y);
            }
            try { drawTile(center.getNeigh(-1, -1), x - 1, y - 1); }
            catch
            {
                drawEmpty(x - 1, y - 1);
            }
            try { drawTile(center.getNeigh(1, 0), x + 1, y); }
            catch
            {
                drawEmpty(x + 1, y);
            }
            try { drawTile(center.getNeigh(1, 1), x + 1, y + 1); }
            catch
            {
                drawEmpty(x + 1, y + 1);
            }
            try { drawTile(center.getNeigh(0, 1), x, y + 1); }
            catch
            {
                drawEmpty(x, y + 1);
            }
            try { drawTile(center.getNeigh(-1, 0), x - 1, y); }
            catch
            {
                drawEmpty(x - 1, y);
            }
            try { drawTile(center.getNeigh(0, -1), x, y - 1); }
            catch
            {
                drawEmpty(x, y - 1);
            }
            try { drawTile(center.getNeigh(1, -1), x + 1, y - 1); }
            catch
            {
                drawEmpty(x + 1, y - 1);
            }
            try { drawTile(center.getNeigh(-1, 1), x - 1, y + 1); }
            catch
            {
                drawEmpty(x - 1, y + 1);
            }
        }

        //Vykresli sousedy vsech sousedu - pokud je mrizka posunuta a je na plose vice nez 9 dilku
        private void drawAll(Tile center, int x, int y)
        {
            n = n + 1;
            try { drawAllNeigh(center.getNeigh(-1, -1), x - 1, y - 1); }
            catch
            {
                drawEmpty(x - 1, y - 1);
            }
            try { drawAllNeigh(center.getNeigh(1, 0), x + 1, y); }
            catch
            {
                drawEmpty(x + 1, y);
            }
            try { drawAllNeigh(center.getNeigh(1, 1), x + 1, y + 1); }
            catch
            {
                drawEmpty(x + 1, y + 1);
            }
            try { drawAllNeigh(center.getNeigh(0, 1), x, y + 1); }
            catch
            {
                drawEmpty(x, y + 1);
            }
            try { drawAllNeigh(center.getNeigh(-1, 0), x - 1, y); }
            catch
            {
                drawEmpty(x - 1, y);
            }
            try { drawAllNeigh(center.getNeigh(0, -1), x, y - 1); }
            catch
            {
                drawEmpty(x, y - 1);
            }
            try { drawAllNeigh(center.getNeigh(1, -1), x + 1, y - 1); }
            catch
            {
                drawEmpty(x + 1, y - 1);
            }
            try { drawAllNeigh(center.getNeigh(-1, 1), x - 1, y + 1); }
            catch
            {
                drawEmpty(x - 1, y + 1);
            }
        }
        //V jinem vlakne nacte mesta a jejich souradnice
        private void Form1_Load(object sender, EventArgs e)
        {
            Thread t = new Thread(new ThreadStart(parseTowns));
            t.Start();
        }

        private void parseTowns()
        {
            HttpWebRequest req = (HttpWebRequest)HttpWebRequest.Create(srv+":"+port + "/obce.xml");
            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream s = resp.GetResponseStream();
            XmlTextReader xr = new XmlTextReader(s);
            xr.Read();
            //Nacteni mest do Dictionary
            while (xr.Read())
            {
                if (xr.NodeType == XmlNodeType.Element)
                {
                    //Pokud je vice obci stejneho nazvu, pouzivam list pointu
                    if(!obce.ContainsKey(xr.GetAttribute(0)))
                        obce.Add(xr.GetAttribute(0), new List<Point>());
                    obce[xr.GetAttribute(0)].Add(new Point(Convert.ToInt32(xr.GetAttribute(1)), Convert.ToInt32(xr.GetAttribute(2))));
                }
            }
        }
        //Vyhledavani mesta
        private void button2_Click(object sender, EventArgs e)
        {
            string obec = textBox4.Text;
            int z = Convert.ToInt32(textBox5.Text);
            if (obce.ContainsKey(obec))
            {
                listBox1.Items.Clear();
                //Pokud je vice mest stejneho nazvu, nabidnu vyber listboxem
                if (obce[obec].Count > 1)
                {
                    for (int i = 0; i < obce[obec].Count; i++)
                    {
                        listBox1.Items.Add(obec + "    X: "  + obce[obec][i].X.ToString() + "  Y: " + obce[obec][i].Y.ToString());
                    }
                    town(obec, 0);
                }
                else
                {
                    town(obec, 0);
                }
            }
        }

        private void textBox4_TextChanged(object sender, EventArgs e)
        {

        }
        private void town(string obec, int i)
        {
            //Prepocet souradnic na dilek aktualniho zvetseni a vykreslini odpovidajici mapy
            int z = Convert.ToInt32(textBox5.Text);
            int x9 = obce[obec][i].X / (int)256;
            int y9 = obce[obec][i].Y / (int)256;
            int xi9 = obce[obec][i].X % (int)256;
            int yi9 = obce[obec][i].Y % (int)256;
            x0 = 0;
            y0 = 0;
            int xz = x9 / (int)Math.Pow(2, 9 - z);
            int yz = y9 / (int)Math.Pow(2, 9 - z);
            int xiz = xz * 256 + xi9;
            int yiz = yz * 256 + yi9;
            center = new Tile(xz, yz, z);
            drawAll(center, 1, 1);
        }
        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            string obec = textBox4.Text;
            town(obec, listBox1.SelectedIndex);
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            //"Tahnuti" mapy mysi
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                x0 += e.X - tmpx;
                y0 += e.Y - tmpy;
                tmpx = e.X;
                tmpy = e.Y;
                try
                {
                    //Pokud se posunu o cely jeden dilek, zmenim dilek centralni na nyni odpovidajici
                    if (x0 >= 256)
                    {
                        center = center.getNeigh(-(x0 / (int)256), 0);
                        x0 = x0 % 256;
                    }
                    if (x0 <= -256)
                    {
                        center = center.getNeigh(-(x0 / (int)256), 0);
                        x0 = -(-x0 % 256);
                    }
                    if (y0 >= 256)
                    {
                        center = center.getNeigh(0, -(y0 / (int)256));
                        y0 = y0 % 256;
                    }
                    if (y0 <= -256)
                    {
                        center = center.getNeigh(0, -(y0 / (int)256));
                        y0 = -(-y0 % 256);
                    }
                }
                catch
                {
                    x0 = y0 = 0;
                }
                n = 0;
                drawAll(center, 1, 1);
            }
        }

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            tmpx = e.X;
            tmpy = e.Y;
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {/*
            x0 += e.X - tmpx;
            y0 += e.Y - tmpy;
            if (x0 >= 256)
            {
                center = center.getNeigh(-(x0 / (int)256), 0);
                x0 = x0 % 256;
            }
            if (x0 <= -256)
            {
                center = center.getNeigh(-(x0 / (int)256), 0);
                x0 = -(-x0 % 256);
            }
            if (y0 >= 256)
            {
                center = center.getNeigh(0,-(y0 / (int)256));
                y0 = y0 % 256;
            }
            if (y0 <= -256)
            {
                center = center.getNeigh(0, -(y0 / (int)256));
                y0 = -(-y0 % 256);
            }
            n = 0;
            drawAll(center, 1, 1);*/
        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == 'Q')
                center = new Tile(center.x * 2, center.y * 2, center.z + 1);
            if (e.KeyChar == 'W')
                center = new Tile(center.x * 2, center.y * 2, center.z - 1);

            drawAll(center, 1, 1);

        }

        private void pictureBox1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            //ZOOMovani mapy
            if (e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                if(center.z+1<=9)
                    center = new Tile(center.x * 2, center.y * 2, center.z + 1); // prepocet centralniho
            }
            if (e.Button == System.Windows.Forms.MouseButtons.Right)
                if(center.z-1>=0)
                    center = new Tile(center.x / 2, center.y / 2, center.z - 1); // prepocet centralniho

            drawAll(center, 1, 1);
        }
        //NEPOUZIVAM, ale nemam cas mazat :)
        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
        }
        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }
        

        private void Form1_MouseMove(object sender, MouseEventArgs e)
        {

        }

    }
}
