﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Net;
using System.IO;
namespace mapa
{
	class Tile
	{
        public int x;
        public int y;
        public int z;
        public Image img;
        public Tile(int X, int Y, int Z)
        {
            if(isValid(X, Y, Z))
            {
            x = X;
            z = Z;
            y = Y;
            img = getImg(x, y, z);
            }
            else{
                throw new Exception("404");
            }
        }
        //Kontrolovani validity - existence dilku
        private bool isValid(int x, int y, int z)
        {
            if (x >= 0 && x <= 3 * Math.Pow(2, z)-1 && y >= 0 && y <= 2 * Math.Pow(2,z)-1)
                return true;
            else return false;
        }
        //Stazeni obrazku
        private Image getImg(int x, int y, int z)
        {
            HttpWebRequest req = (HttpWebRequest)HttpWebRequest.Create(Program.f.srv + ":" + Program.f.port + "/" + z.ToString() + "/" + x.ToString() + "/" + y.ToString() + ".jpg");
            HttpWebResponse resp = (HttpWebResponse)req.GetResponse();
            Stream s = resp.GetResponseStream();
            return Image.FromStream(s);
        }
        //vrati sousedni dilek
        public Tile getNeigh(int dx, int dy)
        {
            if (isValid(x + dx, y + dy, z))
                return new Tile(x + dx, y + dy, z);
            else
                throw new Exception("404");
        }
	}
}
